# Copyright(C) 2007-2011, G. Terry Ross, Draw Metal LLC
# Portions Copyright 2005, @Last Software, Inc.

# DISCLAIMER OF WARRANTIES
# BECAUSE THIS SOFTWARE IS PROVIDED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE SOFTWARE.
# THE SOFTWARE IS PROVIDED "AS IS" WITH ALL FAULTS AND WITHOUT WARRANTY OF ANY KIND,    
# EITHER EXPRESSED, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES AND/OR CONDITIONS OF MERCHANTABILITY, OF SATISFACTORY QUALITY,
# OF FITNESS FOR A PARTICULAR PURPOSE OR USE, OF ACCURACY, OF QUIET ENJOYMENT,
# AND OF NON-INFRINGEMENT OF THIRD PARTY RIGHTS.
# THERE IS NO WARRANTY AS TO THE SOFTWARE'S PERFORMANCE, AGAINST INTERFERENCE WITH
# YOUR ENJOYMENT OF THE SOFTWARE, THAT THE FUNCTIONS CONTAINED IN THE SOFTWARE
# WILL MEET YOUR REQUIREMENTS, THAT THE OPERATION OF THE SOFTWARE WILL BE
# UNINTERRUPTED OR ERROR-FREE, OR THAT DEFECTS IN THE SOFTWARE WILL BE CORRECTED.
# YOU EXPRESSLY ACKNOWLEDGE AND AGREE THAT USE OF THE SOFTWARE IS AT YOUR SOLE RISK
# AND THAT THE ENTIRE RISK AS TO SATISFACTORY QUALITY, PERFORMANCE, ACCURACY AND EFFORT
# IS WITH YOU.  SHOULD THE SOFTWARE PROVE DEFECTIVE, YOU ASSUME THE ENTIRE COST
# OF ALL NECESSARY SERVICING, REPAIR, OR CORRECTION.
# NO ORAL OR WRITTEN INFORMATION OR ADVICE GIVEN BY THE SOFTWARE PROVIDER
# SHALL CREATE A WARRANTY.

Sketchup::require 'ctsMaker/cornu'
Sketchup::require 'ctsMaker/ctsMaker'

CTSMakers.init

if( not file_loaded?( "curve_menu.rb" ) )###
  
  plugins_menu = UI.menu("Plugins").add_submenu( $ctst.to( "Curve Maker" ) )
  
# Last parameter in the next line controls Curve Maker default for displaying equation options
# Should be { CTSMakers.maker( $curve, 'y' ) } to INclude equation options by default
# Should be { CTSMakers.maker( $curve ) } to EXclude equation options by default

  plugins_menu.add_item( $ctst.to( "Draw a Curve" ) ) { CTSMakers.maker( $curve, 'y' ) }
  
  plugins_menu.add_item( $ctst.to( "Display Curve Data" ) ) { CTSMakers.display_data( $curve ) }
  plugins_menu.add_item( $ctst.to( "Select Curves by Attribute" ) ) { CTSMakers.select_by_attribute_value( $curve ) } 
  plugins_menu.add_item( $ctst.to( "About Curve Maker" ) ) { CTSMakers.about_maker( $curve ) }

  draw_menu = UI.menu("Draw").add_submenu( $ctst.to( "Curve Maker" ) )  
  draw_menu.add_item( $ctst.to( 'Archimedes Spiral' ) ) { CurveMakerDraw.select_tool( 'Archimedes Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Bernoulli Spiral' ) ) { CurveMakerDraw.select_tool( 'Bernoulli Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Catenary' ) ) { CurveMakerDraw.select_tool( 'Catenary' ) }
  draw_menu.add_item( $ctst.to( 'Cornu Spline' ) ) { CurveMakerDraw.select_tool( 'Cornu Spline' ) }
  draw_menu.add_item( $ctst.to( 'Cosine' ) ) { CurveMakerDraw.select_tool( 'Cosine' ) }
  draw_menu.add_item( $ctst.to( 'Euler Spiral' ) ) { CurveMakerDraw.select_tool( 'Euler Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Fermat Spiral' ) ) { CurveMakerDraw.select_tool( 'Fermat Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Golden Spiral' ) ) { CurveMakerDraw.select_tool( 'Golden Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Helix' ) )   { CurveMakerDraw.select_tool( 'Helix' ) }
  draw_menu.add_item( $ctst.to( 'Hyperbolic Spiral' ) ) { CurveMakerDraw.select_tool( 'Hyperbolic Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Lituus Spiral' ) ) { CurveMakerDraw.select_tool( 'Lituus Spiral' ) }
  draw_menu.add_item( $ctst.to( 'Parabola' ) ) { CurveMakerDraw.select_tool( 'Parabola' ) }
  draw_menu.add_item( $ctst.to( 'Sine' ) ) { CurveMakerDraw.select_tool( 'Sine' ) }

  UI.add_context_menu_handler do |menu|
    if( CurveMakerEdit.selected_stuff( 'Archimedes Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Archimedes Spiral' ) ) { CurveMakerEdit.edit_curve( 'Archimedes Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Bernoulli Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Bernoulli Spiral' ) ) { CurveMakerEdit.edit_curve( 'Bernoulli Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Catenary' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Catenary' ) ) { CurveMakerEdit.edit_curve( 'Catenary' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Cosine' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Cosine' ) ) { CurveMakerEdit.edit_curve( 'Cosine' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Cornu Spline' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Cornu Spline' ) ) { CurveMakerEdit.edit_curve( 'Cornu Spline' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Euler Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Euler Spiral' ) ) { CurveMakerEdit.edit_curve( 'Euler Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Fermat Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Fermat Spiral' ) ) { CurveMakerEdit.edit_curve( 'Fermat Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Golden Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Golden Spiral' ) ) { CurveMakerEdit.edit_curve( 'Golden Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Helix' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Helix' ) ) { CurveMakerEdit.edit_curve( 'Helix' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Hyperbolic Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Hyperbolic Spiral' ) ){ CurveMakerEdit.edit_curve( 'Hyperbolic Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Lituus Spiral' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Lituus Spiral' ) ){ CurveMakerEdit.edit_curve( 'Lituus Spiral' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Parabola' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Parabola' ) ) { CurveMakerEdit.edit_curve( 'Parabola' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Sine' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Sine' ) ) { CurveMakerEdit.edit_curve( 'Sine' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Archimedes Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + ' ' + $ctst.to( 'Archimedes Spiral' ) + ' ' + $ctst.to( 'Equation' ) ){ CurveMakerEdit.edit_curve( 'Archimedes Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Archimedean Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Archimedean Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Archimedean Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Bernoulli Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Bernoulli Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Bernoulli Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Catenary Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Catenary' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Catenary Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Cosine Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Cosine' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Cosine Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Cotes Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Cotes Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Cotes Spiral Equation') }
    end
    if( CurveMakerEdit.selected_stuff( 'Hyperbolic Cotangent Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Hyperbolic Cotangent Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Hyperbolic Cotangent Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Euler Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Euler Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Euler Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Fermat Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Fermat Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Fermat Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Hyperbolic Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Hyperbolic Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Hyperbolic Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Hyperbolic Tangent Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Hyperbolic Tangent Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Hyperbolic Tangent Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Lituus Spiral Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Lituus Spiral' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Lituus Spiral Equation' ) }
    end
    if( CurveMakerEdit.selected_stuff( 'Sine Equation' ) )
      menu.add_separator
      menu.add_item( $ctst.to( 'Edit' ) + " " + $ctst.to( 'Sine' ) + ' ' + $ctst.to( 'Equation' ) ) { CurveMakerEdit.edit_curve( 'Sine Equation' ) }
    end
    
  end

 # TOOLBAR
 # courtesy of Max Coppoletta of Quarr-IT
 # www.quarr-it.com
 
  toolbar = UI::Toolbar.new $ctst.to( "Curve Maker" )
  
  cmd = UI::Command.new( $ctst.to( 'Archimedes Spiral' ) ) { CurveMakerDraw.select_tool( 'Archimedes Spiral' ) }
          cmd.small_icon = "icons/archi_16.png"
          cmd.large_icon = "icons/archi_24.png"
          cmd.tooltip = $ctst.to( 'Archimedes Spiral' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Bernoulli Spiral' ) { CurveMakerDraw.select_tool( 'Bernoulli Spiral' ) }
          cmd.small_icon = "icons/bern_16.png"
          cmd.large_icon = "icons/bern_24.png"
          cmd.tooltip = $ctst.to( 'Bernoulli Spiral' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Cornu Spline' ) { CurveMakerDraw.select_tool( 'Cornu Spline' ) }
          cmd.small_icon = "icons/cornu_16.png"
          cmd.large_icon = "icons/cornu_24.png"
          cmd.tooltip = $ctst.to( 'Cornu Spline' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Euler Spiral' ) { CurveMakerDraw.select_tool( 'Euler Spiral' ) }
          cmd.small_icon = "icons/euler_16.png"
          cmd.large_icon = "icons/euler_24.png"
          cmd.tooltip = $ctst.to( 'Euler Spiral' )
          toolbar = toolbar.add_item cmd
  
  cmd = UI::Command.new( 'Fermat Spiral' ) { CurveMakerDraw.select_tool( 'Fermat Spiral' ) }
          cmd.small_icon = "icons/fermat_16.png"
          cmd.large_icon = "icons/fermat_24.png"
          cmd.tooltip = $ctst.to( 'Fermat Spiral' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Golden Spiral' ) { CurveMakerDraw.select_tool( 'Golden Spiral' ) }
          cmd.small_icon = "icons/gold_16.png"
          cmd.large_icon = "icons/gold_24.png"
          cmd.tooltip = $ctst.to( 'Golden Spiral' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Helix' ) { CurveMakerDraw.select_tool( 'Helix' ) }
          cmd.small_icon = "icons/helix_16.png"
          cmd.large_icon = "icons/helix_24.png"
          cmd.tooltip = $ctst.to( 'Helix' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Hyperbolic Spiral' ) { CurveMakerDraw.select_tool( 'Hyperbolic Spiral' ) }
          cmd.small_icon = "icons/hyp_16.png"
          cmd.large_icon = "icons/hyp_24.png"
          cmd.tooltip = $ctst.to( 'Hyperbolic Spiral' )
          toolbar = toolbar.add_item cmd

  cmd = UI::Command.new( 'Lituus Spiral' ) { CurveMakerDraw.select_tool( 'Lituus Spiral' ) }
          cmd.small_icon = "icons/lit_16.png"
          cmd.large_icon = "icons/lit_24.png"
          cmd.tooltip = $ctst.to( 'Lituus Spiral' )
          toolbar = toolbar.add_item cmd

end
#-----------------------------------------------------------------------------
file_loaded( "curve_menu.rb" )###
